<Cabbage>
form caption("Synthduino") size(630, 400), colour(96, 181, 99), pluginid("ardu")
keyboard bounds(10, 290, 610, 100)

groupbox bounds(10, 10, 400, 130) text("Amplitude Envelope") fontcolour(96, 181, 99) alpha(0.9)
rslider bounds(10, 35, 100, 100) text("Attack") textcolour("black") channel("attack") range(0.01, 10, 0.01, 0.6, 0.01) textcolour(96, 181, 99) trackercolour(96, 181, 99) 
rslider bounds(110, 35, 100, 100) text("Decay") textcolour("black") channel("decay") range(0.01, 10, 0.01, 0.6, 0.01) textcolour(96, 181, 99) trackercolour(96, 181, 99) 
rslider bounds(210, 35, 100, 100) text("Sustain") textcolour("black") channel("sustain") range(0, 1, 1, 1, 0.01) textcolour(96, 181, 99) trackercolour(96, 181, 99) 
rslider bounds(310, 35, 100, 100) text("Release") textcolour("black") channel("release") range(0.01, 10, 0.5, 0.6, 0.01) textcolour(96, 181, 99) trackercolour(96, 181, 99) 

groupbox bounds(10, 150, 400, 130) text("Filter Envelope") fontcolour(96, 181, 99) alpha(0.9)
rslider bounds(10, 175, 100, 100) text("Attack") textcolour("black") channel("fattack") range(0.01, 10, 0.01, 0.6, 0.01) textcolour(96, 181, 99) trackercolour(96, 181, 99) 
rslider bounds(110, 175, 100, 100) text("Decay") textcolour("black") channel("fdecay") range(0.01, 10, 0.01, 0.6, 0.01) textcolour(96, 181, 99) trackercolour(96, 181, 99) 
rslider bounds(210, 175, 100, 100) text("Sustain") textcolour("black") channel("fsustain") range(0, 1, 1, 1, 0.01) textcolour(96, 181, 99) trackercolour(96, 181, 99) 
rslider bounds(310, 174, 100, 100) text("Release") textcolour("black") channel("frelease") range(0.01, 10, 0.5, 0.6, 0.01) textcolour(96, 181, 99) trackercolour(96, 181, 99) 

groupbox bounds(420, 10, 200, 270) text("Sound") fontcolour(96, 181, 99) alpha(0.9)
rslider bounds(420, 35, 100, 100) text("Resonance") textcolour("black") channel("resonance") range(0, 1, 0.5, 1, 0.01) textcolour(96, 181, 99) trackercolour(96, 181, 99) 
rslider bounds(520, 35, 100, 100) text("Saw/Pulse") textcolour("black") channel("mix") range(0, 1, 0.5, 1, 0.01) textcolour(96, 181, 99) trackercolour(96, 181, 99) 
checkbox bounds(430, 175, 80, 80) channel("detune") 
label bounds(430, 255, 80, 15) text("Detune") fontcolour(96, 181, 99) 
combobox bounds(530, 175, 80, 80) channel("vrate") items("1/4","1/8","1/16","1/32")
label bounds(530, 255, 80, 15) text("Vib Rate") fontcolour(96, 181, 99) 

</Cabbage>
<CsoundSynthesizer>
<CsOptions>
-n -d -+rtmidi=NULL -M0 -m0d --midi-key-cps=4 --midi-velocity-amp=5
</CsOptions>
<CsInstruments>
; Initialize the global variables. 
ksmps = 512
nchnls = 2
0dbfs = 1

alwayson "arduino"

gkpot1 init 0
gkpot2 init 0
gkxaxis init 0
gkyaxis init 0

instr synth

    ;Getting Channels        
    iatt chnget "attack"
    idec chnget "decay"
    isus chnget "sustain"
    irel chnget "release"
    
    ifatt chnget "fattack"
    ifdec chnget "fdecay"
    ifsus chnget "fsustain"
    ifrel chnget "frelease"
    
    kres chnget "resonance"
    
    kdetune chnget "detune"
    
    kmix chnget "mix"
    
    kfreqsaw = p4
    kfreqpulse = p4
    kamp = p5
    
    ;Vibrato 
    ktempo chnget "HOST_BPM"        
    kvsetting chnget "vrate"
    kvrate init 0
    
    if(kvsetting == 1) then    
        kvrate = ktempo/60
    elseif(kvsetting == 2) then
        kvrate = ktempo/60*2
    elseif(kvsetting == 3)then
        kvrate = ktempo/60*4
    elseif(kvsetting == 4) then
        kvrate = ktempo/60*8
    endif
    
    kdepth = gkpot2/10
    kvib lfo kdepth, kvrate
    kvib = cent(kvib)
        
    kfreqsaw *= kvib
    kfreqpulse *= kvib
    
    ;Option to detune oscillators against eachother
    if(kdetune == 1) then
    
        kdcents = 10
        kdcents = cent(kdcents)
        kfreqsaw += kdcents
        kfreqpulse -= kdcents
        
    endif    
    
    ;Pitch Bend
    kpitchbend = gkxaxis*0.00097            ;Scale this value between 0 and 1 (analog input is between 0 and 1023)
    kpitchbend scale kpitchbend, 0.89, 1.12 ;Roughly a major 2nd above and below
    kfreqsaw *= kpitchbend
    kfreqpulse *= kpitchbend
    
    kpw = gkyaxis*0.00097                   ;Scale this value between 0 and 1
        
    kenv madsr iatt, idec, isus, irel
    kfenv madsr ifatt, ifdec, ifsus, ifrel
    
    asaw vco2 kamp*kenv*0.5, kfreqsaw
    apulse vco2 kamp*kenv*0.5, kfreqpulse, 2, kpw
    
    afilt lpf18 (asaw*kmix) + (apulse*(1 - kmix)), gkpot1*20*kfenv, kres, 0.9
    outs afilt, afilt

endin

instr arduino

; Initialize the four variables read
kPot1   init 0
kPot2   init 0
kButton1 init 0
kSoftpot init 0

iPort	serialBegin "/dev/cu.usbmodem142101", 9600	;connect to the arduino with baudrate = 9600
		serialWrite iPort, 1		;Triggering the Arduino (k-rate)

kValue 	= 0
kType 	serialRead iPort		; Read type of data

if (kType >= 128) then

	kIndex = 0
	kSize  serialRead iPort
	    
	loopStart:
	    kValue 	= kValue << 7
	    kByte	serialRead iPort
	    kValue 	= kValue + kByte
	    loop_lt kIndex, 1, kSize, loopStart
	
endif

if (kValue < 0) kgoto continue

if (kType == 128) then		; This is the first pot
	kPot1 	= kValue
elseif (kType == 129) then	; This is the second pot	
	kPot2 	= kValue
elseif (kType == 130) then	; This is the joycon x axis
	kXaxis   = kValue
elseif (kType == 131) then  ; This is the joycon y axis
	kYaxis = kValue
endif

continue:

gkpot1 port kPot1, 0.01
gkpot2 port kPot2, 0.01
gkxaxis port kXaxis, 0.01
gkyaxis port kYaxis, 0.01

endin

</CsInstruments>
<CsScore>
f0 z
</CsScore>
</CsoundSynthesizer>
